diff -r -c -b -N cosmomc/camb/cmbmain.f90 cosmomc_wiggles/camb/cmbmain.f90
*** cosmomc/camb/cmbmain.f90	2009-02-20 00:43:34.000000000 +0100
--- cosmomc_wiggles/camb/cmbmain.f90	2009-10-28 16:19:36.708218142 +0100
***************
*** 636,652 ****
  !     polarization will be calculated. For low values of k we
  !     use a logarithmic spacing. closed case dealt with by SetClosedkValues
           if (CP%WantScalars .and. CP%Reion%Reionization .and. CP%AccuratePolarization) then
!             dlnk0=2._dl/10/AccuracyBoost
              !Need this to get accurate low l polarization
           else
!             dlnk0=5._dl/10/AccuracyBoost
              if (CP%closed) dlnk0=dlnk0/2
           end if
  
           if (CP%AccurateReionization) dlnk0 = dlnk0/2
! 
!          dkn1=0.6_dl/taurst/AccuracyBoost 
!          dkn2=1.1_dl/taurst/AccuracyBoost 
            if (CP%WantTensors .or. CP%WantVectors) then
                dkn1=dkn1  *0.8_dl
                dlnk0=dlnk0/2 !*0.3_dl
--- 636,662 ----
  !     polarization will be calculated. For low values of k we
  !     use a logarithmic spacing. closed case dealt with by SetClosedkValues
           if (CP%WantScalars .and. CP%Reion%Reionization .and. CP%AccuratePolarization) then
! !wig
! !            dlnk0=2._dl/10/AccuracyBoost
!             dlnk0=2._dl/10/AccuracyBoost/kSrcSampleBoost
! !end wig
              !Need this to get accurate low l polarization
+ 
           else
! !wig
! !            dlnk0=5._dl/10/AccuracyBoost
!             dlnk0=5._dl/10/AccuracyBoost/kSrcSampleBoost
! !end wig
              if (CP%closed) dlnk0=dlnk0/2
           end if
  
           if (CP%AccurateReionization) dlnk0 = dlnk0/2
! !wig
! !         dkn1=0.6_dl/taurst/AccuracyBoost 
! !         dkn2=1.1_dl/taurst/AccuracyBoost 
!           dkn1=0.6_dl/taurst/AccuracyBoost/kSrcSampleBoost
!           dkn2=1.1_dl/taurst/AccuracyBoost/kSrcSampleBoost
! !end wig
            if (CP%WantTensors .or. CP%WantVectors) then
                dkn1=dkn1  *0.8_dl
                dlnk0=dlnk0/2 !*0.3_dl
***************
*** 1030,1036 ****
         qmax_int = min(qmax,max_bessels_etak/CP%tau0)
  
  
!        IntSampleBoost=AccuracyBoost
  
  !     Fixing the # of k for the integration. 
        
--- 1040,1048 ----
         qmax_int = min(qmax,max_bessels_etak/CP%tau0)
  
  
! !wig
! !     IntSampleBoost=AccuracyBoost
!       IntSampleBoost=AccuracyBoost/kIntSampleBoost
  
  !     Fixing the # of k for the integration. 
        
diff -r -c -b -N cosmomc/camb/inidriver.F90 cosmomc_wiggles/camb/inidriver.F90
*** cosmomc/camb/inidriver.F90	2008-09-16 18:04:28.000000000 +0200
--- cosmomc_wiggles/camb/inidriver.F90	2009-10-28 16:19:45.772967747 +0100
***************
*** 253,258 ****
--- 253,272 ----
           call Ini_SaveReadValues(trim(outroot) //'params.ini',1)
         end if
  
+ !wig
+            
+        kSrcSampleBoost= Ini_Read_Double('k_src_sample_boost',1.d0)
+        kIntSampleBoost= Ini_Read_Double('k_int_sample_boost',1.d0)
+        DoClsInterpol  = Ini_Read_Logical('do_cls_interpol',.true.)
+        ComputeEveryl  = Ini_Read_Logical('compute_every_l',.true.)
+ 
+        if (FeedbackLevel > 0) then
+           write (*,*)'do_cls_interpol is',DoClsInterpol
+           write (*,*)'compute_every_l is',ComputeEveryl
+           write (*,*)'primordial power spectra is: ',Power_Name
+        endif
+ !end wig
+ 
         call Ini_Close
  
         if (.not. CAMB_ValidateParams(P)) stop 'Stopped due to parameter error'
***************
*** 264,269 ****
--- 278,316 ----
         if (FeedbackLevel > 0) then
           Age = CAMB_GetAge(P) 
           write (*,'("Age of universe/GYr  = ",f7.3)') Age  
+ !wig
+          if (Power_Name.eq.'power_tilt') then
+ 
+              do i=1,P%InitPower%nn
+                 write (*,'("Scalar tilt          = ",f12.8)') P%InitPower%an(i)
+                 write (*,'("Scalar running       = ",f12.8)') P%InitPower%n_run(i)
+                 if (P%WantTensors) then
+                    write (*,'("primordial T/S       = ",f12.8)') P%InitPower%rat(i)
+                    write (*,'("tensor tilt          = ",f12.8)') P%InitPower%ant(i)
+                 endif                
+                 write (*,'("Wiggles amplitude    = ",f12.8)') P%InitPower%amposc(i)
+                 write (*,'("Wiggles frequency    = ",f12.8)') P%InitPower%logomega(i)
+                 write (*,'("Wiggles phase        = ",f12.8)') P%InitPower%phase(i)
+                 write (*,'("Wiggles power        = ",f12.8)') P%InitPower%powosc(i)
+              enddo
+              write (*,'("Wiggles pivot        = ",f12.8)') P%InitPower%k_0_osc
+ 
+           elseif ((Power_Name.eq.'power_sr').or.(Power_Name.eq.'power_dbi')) then
+ 
+              do i=1,P%InitPower%nn
+                 write (*,'("Slow-roll epsilon1   = ",f12.8)') P%InitPower%eps1(i)
+                 write (*,'("Slow-roll epsilon2   = ",f12.8)') P%InitPower%eps2(i)
+ 		write (*,'("Slow-roll epsilon3   = ",f12.8)') P%InitPower%eps3(i)
+                 write (*,'("DBI       delta1     = ",f12.8)') P%InitPower%del1(i)
+                 write (*,'("DBI       gamma      = ",f12.8)') P%InitPower%gam(i)
+                 write (*,'("TPL amplitude        = ",f12.8)') P%InitPower%Xsigma0(i)
+                 write (*,'("TPL scale            = ",f12.8)') P%InitPower%loginvsigma0(i)
+                 write (*,'("TPL phase            = ",f12.8)') P%InitPower%varphi(i)
+              enddo
+           else
+              stop 'Power_Name unknown'
+           endif
+ !end wig
         end if 
  
         call CAMB_GetResults(P)
diff -r -c -b -N cosmomc/camb/Makefile cosmomc_wiggles/camb/Makefile
*** cosmomc/camb/Makefile	2009-10-22 15:59:31.000000000 +0200
--- cosmomc_wiggles/camb/Makefile	2009-10-28 16:24:26.068717962 +0100
***************
*** 1,69 ****
! #CAMB Makefile
  
! #Edit for your compiler
! #Note there are many ifc versions, some of which behave oddly
  
- #Intel , -openmp toggles mutli-processor:
- #note version 10.0 gives wrong result for lensed when compiled with -openmp [fixed in 10.1]
- F90C     = ifort
- FFLAGS = -openmp -O2 -ip -W0 -WB -fpp2 -vec_report0
- 
- # Intel 9 on IA-64 (eg. COSMOS)
- # (do "module load icomp90" before compiling)
- #F90C = ifort
- #FFLAGS = -openmp -fpp2 -w -O3 -ip -mP2OPT_hlo_prefetch=F
- 
- #Intel ifc, add -openmp for multi-processor (some have bugs):
- #F90C     = ifc
- #FFLAGS = -O2 -Vaxlib -ip -W0 -WB -quiet -fpp2
- #some systems can can also add e.g. -tpp7 -xW
- 
- #G95 compiler
- #F90C   = g95
- #FFLAGS = -O2
- 
- #Gfortran compiler: if pre v4.3 add -D__GFORTRAN__
- #F90C     = gfc
- #FFLAGS =  -O2 
- 
- #SGI, -mp toggles multi-processor. Use -O2 if -Ofast gives problems.
- #F90C     = f90
- #FFLAGS  = -Ofast -mp
- 
- #Digital/Compaq fortran, -omp toggles multi-processor
- #F90C    = f90
- #FFLAGS  = -omp -O4 -arch host -math_library fast -tune host -fpe1
- 
- #Absoft ProFortran, single processor:
- #F90C     = f95
- #FFLAGS = -O2 -cpu:athlon -s -lU77 -w -YEXT_NAMES="LCS" -YEXT_SFX="_"
- 
- #NAGF95, single processor:
- #F90C     = f95
- #FFLAGS = -DNAGF95 -O3
- 
- #PGF90
- #F90C = pgf90
- #FFLAGS = -O2 -DESCAPEBACKSLASH
- 
- #Sun V880
- #F90C = mpf90
- #FFLAGS =  -O4 -openmp -ftrap=%none -dalign -DMPI
- 
- #Sun parallel enterprise:
- #F90C     = f95
- #FFLAGS =  -O2 -xarch=native64 -openmp -ftrap=%none
- #try removing -openmp if get bus errors. -03, -04 etc are dodgy.
- 
- #IBM XL Fortran, multi-processor (run gmake)
- #F90C     = xlf90_r
- #FFLAGS  = -DESCAPEBACKSLASH -DIBMXL -qsmp=omp -qsuffix=f=f90:cpp=F90 -O3 -qstrict -qarch=pwr3 -qtune=pwr3
- 
- #Settings for building camb_fits
- #Location of FITSIO and name of library
- FITSDIR       = /home/cpac/cpac-tools/lib
- FITSLIB       = cfitsio
- #Location of HEALPIX for building camb_fits
- HEALPIXDIR    = /home/cpac/cpac-tools/healpix
  
- include ./Makefile_main
\ No newline at end of file
--- 1,91 ----
!  # >>> DESIGNED FOR GMAKE <<<
!  #CAMB System unified Makefile 
  
! ext=$(shell uname | cut -c1-3)
! ifeq ($(ext),IRI)
! F90C=f90	
! FFLAGS = -Ofast -mp -n32 -LANG:recursive=ON
! endif
! 
! ifeq ($(ext),Lin)
! F90C=gfortran
! FFLAGS= -O -fopenmp #-D__GFORTRAN__
! endif 
! 
! ifeq ($(ext),OSF)
! F90C=f90
! FFLAGS= -omp -O -arch host -math_library fast -tune host -fpe1
! endif
! 
! ifeq ($(ext),Sun)
! F90C=f90
! FFLAGS= -O4 -xarch=native64 -openmp -ftrap=%none
! endif
! 
! ifeq ($(ext),AIX)
! F90C=xlf90_r
! FFLAGS= -O4 -qsmp=omp -qmaxmem=-1 -qstrict -qfree=f90 -qsuffix=f=f90:cpp=F90
! endif
! 
! 
! #Files containing evolution equations initial power spectrum module
! EQUATIONS     = equations
! POWERSPECTRUM = power_tilt
! REIONIZATION = reionization
! RECOMBINATION = recfast
! 
! #Module doing non-linear scaling
! NONLINEAR     = halofit
! 
! #Driver program
! DRIVER        = inidriver.F90
! #DRIVER        = sigma8.f90
! #DRIVER        = tester.f90
! 
! 
! CAMBLIB       = libcamb.a
! 
! #Shouldn't need to change anything else...
! 
! F90FLAGS      = $(FFLAGS)
! HEALPIXLD     = -L$(HEALPIXDIR)/lib -lhealpix -L$(FITSDIR) -l$(FITSLIB)
! 
! CAMBOBJ       = constants.o utils.o subroutines.o inifile.o $(POWERSPECTRUM).o $(RECOMBINATION).o $(REIONIZATION).o modules.o \
!         bessels.o $(EQUATIONS).o $(NONLINEAR).o lensing.o cmbmain.o camb.o
! 
! default: camb.$(ext)
! 
! all: camb.$(ext) $(CAMBLIB)
! 
! subroutines.o: constants.o utils.o
! $(POWERSPECTRUM): subroutines.o  inifile.o
! $(RECOMBINATION).o: subroutines.o inifile.o
! $(REIONIZATION).o: constants.o inifile.o
! modules.o: $(REIONIZATION).o
! bessels.o: modules.o
! $(EQUATIONS): bessels.o
! $(NONLINEAR).o:  modules.o
! lensing.o: bessels.o
! cmbmain.o: lensing.o
! camb.o: cmbmain.o
! 
! 
! camb.$(ext): $(CAMBOBJ) $(DRIVER)
! 	$(F90C) $(F90FLAGS) $(CAMBOBJ) $(DRIVER) -o $@
! 
! $(CAMBLIB): $(CAMBOBJ)
! 	ar -r $@ $?
! 
! camb_fits: writefits.f90 $(CAMBOBJ) $(DRIVER)
! 	$(F90C) $(F90FLAGS) -I$(HEALPIXDIR)/include tils.o $(CAMBOBJ) writefits.f90 $(DRIVER) $(HEALPIXLD) -DWRITE_FITS -o $@
! 
! %.o: %.f90
! 	$(F90C) $(F90FLAGS) -c $*.f90
! 
! utils.o:
! 	$(F90C) $(F90FLAGS) -c utils.F90	
! 
! clean:
! 	-rm -f *.o *.a *.d core *.mod
  
  
diff -r -c -b -N cosmomc/camb/modules.f90 cosmomc_wiggles/camb/modules.f90
*** cosmomc/camb/modules.f90	2008-09-16 17:57:58.000000000 +0200
--- cosmomc_wiggles/camb/modules.f90	2009-10-28 16:24:40.040209809 +0100
***************
*** 37,44 ****
          character(LEN=*), parameter :: version = 'Sept_08'
          
          integer :: FeedbackLevel = 0 !if >0 print out useful information about the model
! 
!         logical, parameter :: DebugMsgs=.false. !Set to true to view progress and timing
  
          logical, parameter :: DebugEvolution = .false. !Set to true to do all the evolution for all k
  
--- 37,46 ----
          character(LEN=*), parameter :: version = 'Sept_08'
          
          integer :: FeedbackLevel = 0 !if >0 print out useful information about the model
! !wig
! !        logical, parameter :: DebugMsgs=.false. !Set to true to view progress and timing
!         logical, parameter :: DebugMsgs=.false.
! !end wig
  
          logical, parameter :: DebugEvolution = .false. !Set to true to do all the evolution for all k
  
***************
*** 177,192 ****
  
        real(dl) :: lSampleBoost=1._dl
            !Increase lSampleBoost to increase sampling in lSamp%l for Cl interpolation
!           
!       real(dl) :: AccuracyBoost =1._dl  
! 
! 
            !Decrease step sizes, etc. by this parameter. Useful for checking accuracy.
            !Can also be used to improve speed significantly if less accuracy is required.              
            !or improving accuracy for extreme models. 
            !Note this does not increase lSamp%l sampling or massive neutrino q-sampling
! 
!       real(sp) :: lAccuracyBoost=1. 
            !Boost number of multipoles integrated in Boltzman heirarchy
  
        integer, parameter :: lmin = 2
--- 179,196 ----
  
        real(dl) :: lSampleBoost=1._dl
            !Increase lSampleBoost to increase sampling in lSamp%l for Cl interpolation
! !wig          
! !      real(dl) :: AccuracyBoost =1._dl  
!       real(dl) :: AccuracyBoost =8._dl  
! !end wig
            !Decrease step sizes, etc. by this parameter. Useful for checking accuracy.
            !Can also be used to improve speed significantly if less accuracy is required.              
            !or improving accuracy for extreme models. 
            !Note this does not increase lSamp%l sampling or massive neutrino q-sampling
! !wig
! !      real(sp) :: lAccuracyBoost=1. 
!       real(sp) :: lAccuracyBoost=2. 
! !end wig
            !Boost number of multipoles integrated in Boltzman heirarchy
  
        integer, parameter :: lmin = 2
***************
*** 202,208 ****
        integer, parameter:: l0max=4000
  
  !     lmax is max possible number of l's evaluated
!       integer, parameter :: lmax_arr = 100+l0max/7
   
          contains
        
--- 206,219 ----
        integer, parameter:: l0max=4000
  
  !     lmax is max possible number of l's evaluated
! !wig
! !      integer, parameter :: lmax_arr = 100+l0max/7
!       integer, parameter :: lmax_arr = 100+l0max
!       real(dl) :: kSrcSampleBoost=1._dl
!       real(dl) :: kIntSampleBoost=1._dl
!       logical :: DoClsInterpol=.true.
!       logical :: ComputeEveryl=.true.
! !end wig
   
          contains
        
***************
*** 554,559 ****
--- 565,589 ----
          integer lind, lvar, step,top,bot,ls(lmax_arr)
          real(dl) AScale
      
+ !wig        
+         if (ComputeEveryl) then
+            write(*,*) 'Warning: computing every l'           
+            if (max_l.gt.lmax_arr) then
+               write(*,*)'lmax_arr maxl',lmax_arr,max_l
+               stop
+            endif
+            lind=0
+            do lvar=2, max_l
+               lind=lind+1
+               ls(lind)=lvar 
+            end do
+ 
+            lSet%l0=lind
+            lSet%l = ls(1:lind)
+ 
+         else
+ !end wig
+ 
          Ascale=scale/lSampleBoost       
        
          lind=0
***************
*** 677,682 ****
--- 707,715 ----
          end if
          lSet%l0=lind
          lSet%l(1:lind) = ls(1:lind)
+ !wig        
+         endif
+ !end wig
          
        end subroutine initlval
  
***************
*** 696,702 ****
  
        xl = real(lSet%l(1:lSet%l0),dl)
        call spline(xl,iCl(1),max_ind,cllo,clhi,ddCl(1))
!      
              llo=1
              do il=lmin,lSet%l(max_ind)
                 xi=il
--- 729,736 ----
  
        xl = real(lSet%l(1:lSet%l0),dl)
        call spline(xl,iCl(1),max_ind,cllo,clhi,ddCl(1))
! !wig
!       if (DoClsInterpol) then
              llo=1
              do il=lmin,lSet%l(max_ind)
                 xi=il
***************
*** 712,717 ****
--- 746,765 ----
                         +(b0**3-b0)*ddCl(lhi))*ho**2/6
                
              end do
+       else
+         llo=1
+          do il=2,lSet%l(max_ind)
+             xi=il
+             if ((xi > lSet%l(llo+1)).and.(llo < max_ind)) then
+                llo=llo+1
+             end if
+ 
+             all_Cl(il) = iCl(llo+1)
+ 
+          end do
+          all_Cl(2)=iCl(1)
+       endif
+ !end wig 
  
        end subroutine InterpolateClArr
  
***************
*** 2018,2023 ****
--- 2066,2075 ----
               dlnkh = 0.02
               points = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/dlnkh+1
  !             dlnkh = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/(points-0.999)
+ !wig
+              write(*,*)'Transfert_SaveToFiles: points= ',points
+              write(*,*)'you may need to increase this to sample HF oscillations!'
+ !endwig
               allocate(outpower(points,CP%InitPower%nn))
               do in = 1, CP%InitPower%nn
                call Transfer_GetMatterPower(MTrans,outpower(1,in), itf, in, minkh,dlnkh, points)
diff -r -c -b -N cosmomc/camb/params.ini cosmomc_wiggles/camb/params.ini
*** cosmomc/camb/params.ini	2008-03-26 15:24:18.000000000 +0100
--- cosmomc_wiggles/camb/params.ini	2009-10-28 16:24:52.501027579 +0100
***************
*** 1,12 ****
  #Parameters for CAMB
  
  #output_root is prefixed to output file names
! output_root = test
  
  #What to do
  get_scalar_cls = T
  get_vector_cls = F
! get_tensor_cls = F
  get_transfer   = F
  
  #if do_lensing then scalar_output_file contains additional columns of l^4 C_l^{pp} and l^3 C_l^{pT}
--- 1,12 ----
  #Parameters for CAMB
  
  #output_root is prefixed to output file names
! output_root = tpl
  
  #What to do
  get_scalar_cls = T
  get_vector_cls = F
! get_tensor_cls = T
  get_transfer   = F
  
  #if do_lensing then scalar_output_file contains additional columns of l^4 C_l^{pp} and l^3 C_l^{pT}
***************
*** 32,42 ****
  #Main cosmological parameters, neutrino masses are assumed degenerate
  # If use_phyical set phyiscal densities in baryone, CDM and neutrinos + Omega_k
  use_physical   = T
! ombh2          = 0.022
! omch2          = 0.12
  omnuh2         = 0
  omk            = 0
! hubble         = 70
  #effective equation of state parameter for dark energy, assumed constant
  w              = -1
  #constant comoving sound speed of the dark energy (1=quintessence)
--- 32,42 ----
  #Main cosmological parameters, neutrino masses are assumed degenerate
  # If use_phyical set phyiscal densities in baryone, CDM and neutrinos + Omega_k
  use_physical   = T
! ombh2          = 0.0221
! omch2          = 0.1059
  omnuh2         = 0
  omk            = 0
! hubble         = 72.46
  #effective equation of state parameter for dark energy, assumed constant
  w              = -1
  #constant comoving sound speed of the dark energy (1=quintessence)
***************
*** 63,68 ****
--- 63,76 ----
  #Fraction of total omega_nu h^2 accounted for by each eigenstate, eg. 0.5 0.5
  nu_mass_fractions = 1
  
+ #Type of initial power spectrum: power_tilt or power_sr
+ power_name = power_sr
+  
+ ######################################################################################
+ 
+ #for power_tilt power spectra
+ 
+ 
  #Initial power spectrum, amplitude, spectral index and running. Pivot k in Mpc^{-1}.
  initial_power_num         = 1
  pivot_scalar              = 0.05
***************
*** 96,101 ****
--- 104,140 ----
  RECFAST_Heswitch = 6
  
  
+ #primordial power_tilted wiggle
+ osc_logomega(1)           = 1.
+ osc_amp(1)                = 0.
+ osc_phase(1)              = 0.
+ osc_logpower(1)           = 0.
+ osc_pivot                 = 0.05
+ 
+ #####################################################################################
+ 
+ #for power_sr power spectra
+ 
+ #slow-roll parameters
+ ln[10^{10} P_scalar] = 0.303161E+01
+ eps1(1) = 0.210391E-02
+ eps2(1) = 0.421584E-01
+ eps3(1) = 0
+ 
+ #dbi parameter
+ gam(1) = 1.
+ del1(1) = 0.
+ 
+ #wiggles parameters
+ logeps1invsigma0(1) = 1.
+ Xsigma0(1) = 0.
+ varphi(1) = 0
+ 
+ #tpl pivot
+ k_star = 0.05
+ 
+ #####################################################################################
+ 
  #Initial scalar perturbation mode (adiabatic=1, CDM iso=2, Baryon iso=3, 
  # neutrino density iso =4, neutrino velocity iso = 5) 
  initial_condition   = 1
***************
*** 186,188 ****
--- 225,239 ----
  #interpolation errors may be up to 3%
  #Decrease to speed up non-flat models a bit
  l_sample_boost          = 1
+ 
+ # Boost the sampling on k sources only, in unit of AccuracyBoost
+ k_src_sample_boost      = 1.
+ 
+ # Boost the sampling on k line of sight integral only, in unit of AccuracyBoost
+ k_int_sample_boost      = 1.
+ 
+ #Use spline interpolation for the Cls
+ do_cls_interpol         = T
+  
+ # Remove undersampling of the Cls: if true lSampleBoost has no effect
+ compute_every_l         = F
